setfenv(1, ShinyEnv)

local L = ShinyLocale

CONFIG_VERSION = 2.0

SHINY_AGILITY          = "AGILITY"
SHINY_ARCANERESISTANCE = "ARCANERESISTANCE"
SHINY_ARMOR            = "ARMOR"
SHINY_ARTIFACTITEMLEVEL = "ARTIFACTITEMLEVEL"
SHINY_ARTIFACTRANK     = "ARTIFACTRANK"
SHINY_ATTACKPOWER      = "ATTACKPOWER"
SHINY_BLOCK            = "BLOCK"
SHINY_CRITICAL         = "CRITICAL"
SHINY_DODGE            = "DODGE"
SHINY_ENCHANT          = "ENCHANT"
SHINY_EXPERTISE        = "EXPERTISE"
SHINY_FIRERESISTANCE   = "FIRERESISTANCE"
SHINY_FROSTRESISTANCE  = "FROSTRESISTANCE"
SHINY_HASTE            = "HASTE"
SHINY_HIT              = "HIT"
SHINY_INTELLECT        = "INTELLECT"
SHINY_ITEMLEVEL        = "ITEMLEVEL"
SHINY_MASTERY          = "MASTERY"
SHINY_NATURERESISTANCE = "NATURERESISTANCE"
SHINY_PARRY            = "PARRY"
SHINY_PASSTHRU         = "PASSTHRU"
SHINY_PRIMARYSTAT      = "PRIMARYSTAT"
SHINY_PVPPOWER         = "PVPPOWER"
SHINY_PVPRESILIENCE    = "PVPRESILIENCE"
SHINY_SHADOWRESISTANCE = "SHADOWRESISTANCE"
SHINY_SPELLPENETRATION = "SPELLPENETRATION"
SHINY_SPELLPOWER       = "SPELLPOWER"
SHINY_SPIRIT           = "SPIRIT"
SHINY_STAMINA          = "STAMINA"
SHINY_STRENGTH         = "STRENGTH"
SHINY_VERSATILITY      = "VERSATILITY"
SHINY_WEAPONDAMAGE     = "WEAPONDAMAGE"
SHINY_WEAPONDPS        = "WEAPONDPS"
SHINY_WEAPONSPEED      = "WEAPONSPEED"


SHINY_PATTERN_OTHER   = "OTHER"
SHINY_PATTERN_EQUIP   = "EQUIP"
SHINY_PATTERN_CHANCE  = "CHANCE"
SHINY_PATTERN_CUSTOM  = "CUSTOM"
SHINY_PATTERN_ENCHANT = "ENCHANT"
SHINY_PATTERN_USE     = "USE"
SHINY_PATTERN_STAT    = "STAT"
SHINY_PATTERN_PARTIAL = "PARTIAL"
SHINY_PATTERN_SPECIAL = "SPECIAL"


PRIMARY_STAT_MAP = {
	[LE_UNIT_STAT_STRENGTH]  = SHINY_STRENGTH,
	[LE_UNIT_STAT_AGILITY]   = SHINY_AGILITY,
	[LE_UNIT_STAT_INTELLECT] = SHINY_INTELLECT,
}


PATTERN_MAP = {
	{ L["{STAT_NUMBER} Agility"],                               SHINY_AGILITY,          { SHINY_PATTERN_STAT, SHINY_PATTERN_PARTIAL } },
	{ L["Agility by {STAT_NUMBER}"],                               SHINY_AGILITY,          SHINY_PATTERN_PARTIAL },
	
	{ L["{STAT_NUMBER} Stamina"],                               SHINY_STAMINA,          { SHINY_PATTERN_STAT, SHINY_PATTERN_PARTIAL } },
	{ L["Stamina by {STAT_NUMBER}"],                               SHINY_STAMINA,          SHINY_PATTERN_PARTIAL },
	
	{ L["{STAT_NUMBER} Spirit"],                                SHINY_SPIRIT,           { SHINY_PATTERN_STAT, SHINY_PATTERN_PARTIAL } },
	{ L["Spirit by {STAT_NUMBER}"],                                SHINY_SPIRIT,           SHINY_PATTERN_PARTIAL },
	
	{ L["{STAT_NUMBER} Intellect"],                             SHINY_INTELLECT,        { SHINY_PATTERN_STAT, SHINY_PATTERN_PARTIAL } },
	{ L["Intellect by {STAT_NUMBER}"],                             SHINY_INTELLECT,        SHINY_PATTERN_PARTIAL },
	
	{ L["{STAT_NUMBER} Strength"],                              SHINY_STRENGTH,         { SHINY_PATTERN_STAT, SHINY_PATTERN_PARTIAL } },
	{ L["Strength by {STAT_NUMBER}"],                              SHINY_STRENGTH,         SHINY_PATTERN_PARTIAL },
	
	{ L["{STAT_NUMBER} Versatility"],                           SHINY_VERSATILITY,      { SHINY_PATTERN_STAT, SHINY_PATTERN_PARTIAL } },
	{ L["Versatility by {STAT_NUMBER}"],                           SHINY_VERSATILITY,      SHINY_PATTERN_PARTIAL },
	
	{ L["{STAT_NUMBER} [Aa]ttack [Pp]ower"],                    SHINY_ATTACKPOWER,      { SHINY_PATTERN_STAT, SHINY_PATTERN_PARTIAL } },
	{ L["Equip: Increases attack power by {STAT_NUMBER}"],         SHINY_ATTACKPOWER,      SHINY_PATTERN_EQUIP },
	{ L["attack power by {STAT_NUMBER}"],                          SHINY_ATTACKPOWER,      SHINY_PATTERN_PARTIAL },
					
	{ L["Equip: Increases your expertise by {STAT_NUMBER}"],       SHINY_EXPERTISE,        SHINY_PATTERN_EQUIP },
	{ L["expertise by {STAT_NUMBER}"],                             SHINY_EXPERTISE,        SHINY_PATTERN_PARTIAL },
	{ L["{STAT_NUMBER} Expertise"],                             SHINY_EXPERTISE,        { SHINY_PATTERN_STAT, SHINY_PATTERN_PARTIAL } },
							
	{ L["Equip: Increases your haste by {STAT_NUMBER}"],           SHINY_HASTE,            SHINY_PATTERN_EQUIP },
	{ L["haste by {STAT_NUMBER}"],                                 SHINY_HASTE,            SHINY_PATTERN_PARTIAL },
	{ L["{STAT_NUMBER} [hH]aste"],                              SHINY_HASTE,            { SHINY_PATTERN_STAT, SHINY_PATTERN_PARTIAL } },
					
	{ L["Equip: Increases your hit by {STAT_NUMBER}"],             SHINY_HIT,              SHINY_PATTERN_EQUIP },
	{ L["hit by {STAT_NUMBER}"],                                   SHINY_HIT,              SHINY_PATTERN_PARTIAL },
	{ L["{STAT_NUMBER} Hit"],                                   SHINY_HIT,              { SHINY_PATTERN_STAT, SHINY_PATTERN_PARTIAL } },
					
	{ L["Equip: Increases your critical strike by {STAT_NUMBER}"], SHINY_CRITICAL,         SHINY_PATTERN_EQUIP },
	{ L["critical strike by {STAT_NUMBER}"],                       SHINY_CRITICAL,         SHINY_PATTERN_PARTIAL },
	{ L["{STAT_NUMBER} Critical Strike"],                       SHINY_CRITICAL,         { SHINY_PATTERN_STAT, SHINY_PATTERN_PARTIAL } },

	{ L["Item Level %d*"],                                     SHINY_ITEMLEVEL,        SHINY_PATTERN_STAT },

	{ L["primary stat by {STAT_NUMBER}"],                      SHINY_PRIMARYSTAT,        SHINY_PATTERN_PARTIAL },

	{ L["{STAT_NUMBER} Item Levels"],                          SHINY_ARTIFACTITEMLEVEL,        SHINY_PATTERN_STAT },
	{ L["{STAT_NUMBER} Rank:"],                          		SHINY_ARTIFACTRANK,        		SHINY_PATTERN_STAT },
					
	{ L["{STAT_NUMBER} Armor"],                                 SHINY_ARMOR,            { SHINY_PATTERN_STAT, SHINY_PATTERN_PARTIAL } },
	{ L["Equip: Armor increased by {STAT_NUMBER}"],             SHINY_ARMOR,            SHINY_PATTERN_EQUIP  },

	{ L["Equip: Increases your parry by {STAT_NUMBER}"],           SHINY_PARRY,            SHINY_PATTERN_EQUIP },
	{ L["parry by {STAT_NUMBER}"],                                 SHINY_PARRY,            SHINY_PATTERN_PARTIAL },
	{ L["{STAT_NUMBER} Parry"],                                 SHINY_PARRY,            { SHINY_PATTERN_STAT, SHINY_PATTERN_PARTIAL } },

	{ L["Equip: Increases your block by {STAT_NUMBER}"],           SHINY_BLOCK,            SHINY_PATTERN_EQUIP },
	{ L["block by {STAT_NUMBER}"],                                 SHINY_BLOCK,            SHINY_PATTERN_PARTIAL },
	{ L["{STAT_NUMBER} Block"],                                 SHINY_BLOCK,            { SHINY_PATTERN_STAT, SHINY_PATTERN_PARTIAL } },

	{ L["Equip: Increases your dodge by {STAT_NUMBER}"],           SHINY_DODGE,            SHINY_PATTERN_EQUIP },
	{ L["dodge by {STAT_NUMBER}"],                                 SHINY_DODGE,            SHINY_PATTERN_PARTIAL },
	{ L["{STAT_NUMBER} Dodge"],                                 SHINY_DODGE,            { SHINY_PATTERN_STAT, SHINY_PATTERN_PARTIAL } },
		
	{ L["Equip: Increases your pvp power by {STAT_NUMBER}"],       SHINY_PVPPOWER,         SHINY_PATTERN_EQUIP },
	{ L["{STAT_NUMBER} PvP Power"],                             SHINY_PVPPOWER,         { SHINY_PATTERN_STAT, SHINY_PATTERN_PARTIAL }  },

	{ L["Equip: Increases your pvp resilience by {STAT_NUMBER}"],  SHINY_PVPRESILIENCE,    SHINY_PATTERN_EQUIP },
	{ L["pvp resilience by {STAT_NUMBER}"],                        SHINY_PVPRESILIENCE,    SHINY_PATTERN_PARTIAL },
	{ L["{STAT_NUMBER} PvP Resilience"],                        SHINY_PVPRESILIENCE,    { SHINY_PATTERN_STAT, SHINY_PATTERN_PARTIAL } },

	{ L["{STAT_NUMBER} Fire Resistance"],                       SHINY_FIRERESISTANCE,   { SHINY_PATTERN_STAT, SHINY_PATTERN_PARTIAL } },
	{ L["{STAT_NUMBER} Frost Resistance"],                      SHINY_FROSTRESISTANCE,  { SHINY_PATTERN_STAT, SHINY_PATTERN_PARTIAL } },
	{ L["{STAT_NUMBER} Nature Resistance"],                     SHINY_NATURERESISTANCE, { SHINY_PATTERN_STAT, SHINY_PATTERN_PARTIAL } },
	{ L["{STAT_NUMBER} Shadow Resistance"],                     SHINY_SHADOWRESISTANCE, { SHINY_PATTERN_STAT, SHINY_PATTERN_PARTIAL } },
	{ L["{STAT_NUMBER} Arcane Resistance"],                     SHINY_ARCANERESISTANCE, { SHINY_PATTERN_STAT, SHINY_PATTERN_PARTIAL } },
					
	{ L["Equip: Increases spell power by {STAT_NUMBER}"],          SHINY_SPELLPOWER,       SHINY_PATTERN_EQUIP },
	{ L["spell power by {STAT_NUMBER}"],                           SHINY_SPELLPOWER,       SHINY_PATTERN_PARTIAL },
	{ L["{STAT_NUMBER} Spell Power"],                           SHINY_SPELLPOWER,       { SHINY_PATTERN_STAT, SHINY_PATTERN_PARTIAL } },
	
	{ L["Equip: Increases spell penetration by {STAT_NUMBER}"],    SHINY_SPELLPENETRATION, SHINY_PATTERN_EQUIP },
	{ L["spell penetration by {STAT_NUMBER}"],                     SHINY_SPELLPENETRATION, SHINY_PATTERN_PARTIAL },
	{ L["{STAT_NUMBER} Spell Penetration"],                     SHINY_SPELLPENETRATION, { SHINY_PATTERN_STAT, SHINY_PATTERN_PARTIAL } },
					
	{ L["%({STAT_NUMBER} damage per second%)"],                    SHINY_WEAPONDPS,        SHINY_PATTERN_STAT },

	{ L["{DAMAGE_RANGE} Damage"],                                  SHINY_WEAPONDAMAGE,     SHINY_PATTERN_STAT },
	
	{ L["Speed {STAT_NUMBER}"],                                    SHINY_WEAPONSPEED,      SHINY_PATTERN_STAT },

	{ L["Equip: Increases your mastery by {STAT_NUMBER}"],         SHINY_MASTERY,          SHINY_PATTERN_EQUIP },
	{ L["mastery by {STAT_NUMBER}"],                               SHINY_MASTERY,          SHINY_PATTERN_PARTIAL },
	{ L["{STAT_NUMBER} Mastery"],                               SHINY_MASTERY,          { SHINY_PATTERN_STAT, SHINY_PATTERN_PARTIAL } },

	{ L["^Binds when picked up"],                              SHINY_PASSTHRU,         SHINY_PATTERN_SPECIAL },
	{ L["^Binds on equip"],                                    SHINY_PASSTHRU,         SHINY_PATTERN_SPECIAL },
	{ L["^Soulbound"],                                         SHINY_PASSTHRU,         SHINY_PATTERN_SPECIAL },
	{ L["^Unique"],                                            SHINY_PASSTHRU,         SHINY_PATTERN_SPECIAL },
	{ L["^Unique-Equipped"],                                   SHINY_PASSTHRU,         SHINY_PATTERN_SPECIAL },
	{ L["^Enchanted"],                                         SHINY_PASSTHRU,         SHINY_PATTERN_SPECIAL },
	{ L["^Legacy Set"],                                        SHINY_PASSTHRU,         SHINY_PATTERN_SPECIAL },
	{ L["^Chance on hit"],                                     SHINY_PASSTHRU,         SHINY_PATTERN_SPECIAL },
	{ L["^Quest"],                            				   SHINY_PASSTHRU,         SHINY_PATTERN_SPECIAL },
	{ L["^Binds to Battle.net Account"],                       SHINY_PASSTHRU,         SHINY_PATTERN_SPECIAL },
	{ L["%({STAT_NUMBER} %a+ Cooldown%)"],                           SHINY_PASSTHRU,         SHINY_PATTERN_SPECIAL },
}


DEFAULT_COLORS = {
	[SHINY_AGILITY]          = "ffee03",
	[SHINY_ARCANERESISTANCE] = "a0f2ff",
	[SHINY_ARMOR]            = "b9b9b9",
	[SHINY_ATTACKPOWER]      = "ff494f",
	[SHINY_BLOCK]            = "a2793c",
	[SHINY_CRITICAL]         = "e8850d",
	[SHINY_DODGE]            = "bcff00",
	[SHINY_ENCHANT]          = "00ff00",
	[SHINY_EXPERTISE]        = "bbff00",
	[SHINY_FIRERESISTANCE]   = "ff8300",
	[SHINY_FROSTRESISTANCE]  = "188bff",
	[SHINY_HASTE]            = "b3eeff",
	[SHINY_HIT]              = "00ffc7",
	[SHINY_INTELLECT]        = "b395ff",
	[SHINY_ITEMLEVEL]        = "f2c038",
	[SHINY_MASTERY]	         = "ff73ba",
	[SHINY_NATURERESISTANCE] = "87ff3c",
	[SHINY_PARRY]            = "f600ff",
	[SHINY_PVPPOWER]         = "686eff",
	[SHINY_PVPRESILIENCE]    = "686eff",
	[SHINY_ARTIFACTRANK]     = "87ff3c",
	[SHINY_ARTIFACTITEMLEVEL] = "87ff3c",
	[SHINY_SHADOWRESISTANCE] = "bd33b1",
	[SHINY_SPELLPENETRATION] = "ffffff",
	[SHINY_SPELLPOWER]	     = "ff73ba",
	[SHINY_SPIRIT]           = "b7ffb8",
	[SHINY_STAMINA]          = "dda357",
	[SHINY_STRENGTH]         = "ff000a",
	[SHINY_VERSATILITY]      = "b7aa88",
	[SHINY_WEAPONDAMAGE]     = "ff8930",
	[SHINY_WEAPONDPS]        = "ff96ad",
	[SHINY_WEAPONSPEED]      = "fff250",
	
	[SHINY_PASSTHRU]         = false,
	[SHINY_PRIMARYSTAT]      = false,

	-- Unspecified
	["*"]	 = "ffffff",	-- Default for unspecified
}


COLOR_NAME_MAP = {
	[SHINY_AGILITY]          = L["Agility"],
	[SHINY_ATTACKPOWER]      = L["Attack Power"],
	[SHINY_ARCANERESISTANCE] = L["Arcane Resistance"],
	[SHINY_ARMOR]            = L["Armor"],
	[SHINY_BLOCK]            = L["Block Rating"],
	[SHINY_CRITICAL]         = L["Critical Strike"],
	[SHINY_WEAPONDAMAGE]     = L["Weapon Damage"],
	[SHINY_DODGE]            = L["Dodge Rating"],
	[SHINY_WEAPONDPS]        = L["Weapon DPS"],
	[SHINY_ENCHANT]          = L["Enchant Color"],
	[SHINY_EXPERTISE]        = L["Expertise Rating"],
	[SHINY_FIRERESISTANCE]   = L["Fire Resistance"],
	[SHINY_FROSTRESISTANCE]  = L["Frost Resistance"],
	[SHINY_HASTE]            = L["Haste Rating"],
	[SHINY_HIT]              = L["Hit Rating"],
	[SHINY_ITEMLEVEL]        = L["Item Level"],
	[SHINY_ARTIFACTITEMLEVEL] = L["Artifact Item Level"],
	[SHINY_ARTIFACTRANK]      = L["Artifact Talent Rank"],
	[SHINY_INTELLECT]        = L["Intellect"],
	[SHINY_MASTERY]          = L["Mastery Rating"],
	[SHINY_NATURERESISTANCE] = L["Nature Resistance"],
	[SHINY_PARRY]            = L["Parry Rating"],
	[SHINY_PVPPOWER]         = L["PvP Power"],
	[SHINY_PVPRESILIENCE]    = L["PvP Resilience"],
	[SHINY_SPELLPOWER]       = L["Spell Power"],
	[SHINY_WEAPONSPEED]      = L["Weapon Speed"],
	[SHINY_SPELLPENETRATION] = L["Spell Penetration"],
	[SHINY_SPIRIT]           = L["Spirit"],
	[SHINY_SHADOWRESISTANCE] = L["Shadow Resistance"],
	[SHINY_STAMINA]          = L["Stamina"],
	[SHINY_STRENGTH]         = L["Strength"],
	[SHINY_VERSATILITY]      = L["Versatility"],
}


DEFAULT_OPTIONS = {
	DEBUG = false,

	ENABLE_CACHE = true,
	ENABLE_CHANCE = true,
	ENABLE_ENCHANT = true,
	ENABLE_EQUIP = true,
	ENABLE_MISC = true,
	ENABLE_PARTIAL_MATCHES = true,
	ENABLE_SOCKET_GEM = true,
	ENABLE_STAT_STRIP_COLORS = true,
	ENABLE_USE = true,

	SHORTEN_CHANCE = true,
	SHORTEN_ENCHANT = true,
	SHORTEN_EQUIP = true,
	SHORTEN_SEPARATOR = ", ",
	SHORTEN_SOCKET_GEM = true,
	SHORTEN_USE = true,
}